#ifndef MMC_QUEUE_H
#define MMC_QUEUE_H

struct request;
struct task_struct;

struct mmc_queue {
	struct mmc_card		*card;
	struct task_struct	*thread;
	struct semaphore	thread_sem;
	unsigned int		flags;
	struct request		*req;
	int			(*issue_fn)(struct mmc_queue *, struct request *);
	void			*data;
	struct request_queue	*queue;
	struct scatterlist	*sg;
	char			*bounce_buf;
	struct scatterlist	*bounce_sg;
	unsigned int		bounce_sg_len;
};

extern int mmc_init_queue_dup(struct mmc_queue *, struct mmc_card *, spinlock_t *);
extern void mmc_cleanup_queue_dup(struct mmc_queue *);
extern void mmc_queue_suspend_dup(struct mmc_queue *);
extern void mmc_queue_resume_dup(struct mmc_queue *);

extern unsigned int mmc_queue_map_sg_dup(struct mmc_queue *);
extern void mmc_queue_bounce_pre_dup(struct mmc_queue *);
extern void mmc_queue_bounce_post_dup(struct mmc_queue *);

#endif
